#include "tinyinst.h"
#include "instruction.h"

class SSLInstr : public TinyInst {
public:
	SSLInstr() : ssl_read_addr(0), ssl_write_addr(0), write_breakpoint_addr(0) {}

protected:
	virtual void OnModuleLoaded(void* module, char* module_name) override;

	virtual InstructionResult InstrumentInstruction(ModuleInfo* module,
		Instruction& inst,
		size_t bb_address,
		size_t instruction_address) override;

	virtual bool OnException(Exception* exception_record) override;

	char* ReadTextFile(char* filename);

	size_t Replace(char* buf, size_t buf_size);

	size_t ssl_read_addr, ssl_write_addr;
	size_t write_breakpoint_addr;
	char* replace_buf_remote;
};
	